#ifndef BEST_HPP
#define BEST_HPP

#include "Common.hpp"
#include "Problem.hpp"

class Best
{
public:
    Best();
    ~Best();

    void load(uint64_t id);
    bool update(const Solution& solution, bool saveChanges = true);

    const Solution& getSolution() const { return m_solution; }
    uint64_t getScore() const { return m_score; }

private:
    void parse();

private:
    uint64_t m_id;
    Problem m_problem;
    std::string m_solutionData;
    Solution m_solution;
    uint64_t m_score;
};

#endif
