#include "CalcScore.hpp"
#include "Problem.hpp"
#include "IsValid.hpp"
#include <limits>

uint64_t calcScore(const Problem& problem,
                   const Solution& solution)
{
    uint64_t score = 0;
    for (Point h : problem.m_hole)
    {
        uint64_t minD = std::numeric_limits<uint64_t>::max();
        for (Point v : solution.m_vertices)
        {
            minD = std::min(minD, calcD(h, v));
        }
        score += minD;
    }

    return score;
}
