#ifndef DEBUGGRAPHICS_HPP
#define DEBUGGRAPHICS_HPP

#include "Common.hpp"
#include "Problem.hpp"
#include "ThreadUtils.hpp"

class FastPoints;

class DebugGraphics
{
public:
    DebugGraphics(const Problem& problem,
                  const FastPoints& fastPoints,
                  const std::vector<Point>& points);
    ~DebugGraphics();

    void create();
    void destroy();
    bool destroyed();

    void update(const Solution& solution,
                const std::string& text);

private:
    const Problem& m_problem;
    const FastPoints& m_fastPoints;
    const std::vector<Point>& m_points;
    Thread m_thread;
    Mutex m_mutex;
    Solution m_solution;
    std::string m_text;
    bool m_destroy = false;
    bool m_destroyed = false;
    bool m_update = false;

private:
    DebugGraphics(const DebugGraphics& other) = delete;
    DebugGraphics(DebugGraphics&& other) = delete;
    DebugGraphics& operator=(const DebugGraphics& other) = delete;
    DebugGraphics& operator=(DebugGraphics&& other) = delete;
};

#endif
