#ifndef HTTP_HPP
#define HTTP_HPP

#include "Common.hpp"

namespace Http
{
    void init();
    void cleanup();

    bool get(const std::string& url,
             const std::vector<std::string>* pHeaders,
             std::string* pResponse,
             std::string* pMsg = nullptr);

    bool getQuery(const std::string& url,
                  const std::vector<std::pair<std::string, std::string>>& query,
                  const std::vector<std::string>* pHeaders,
                  std::string* pResponse,
                  std::string* pMsg = nullptr);

    bool post(const std::string& url,
              const std::string& request,
              const std::string& contentType,
              const std::vector<std::string>* pHeaders,
              std::string* pResponse,
              std::string* pMsg = nullptr);

    bool postQuery(const std::string& url,
                   const std::vector<std::pair<std::string, std::string>>& query,
                   const std::vector<std::string>* pHeaders,
                   std::string* pResponse,
                   std::string* pMsg = nullptr);
}

#endif
