#ifndef ISVALID_HPP
#define ISVALID_HPP

#include "Common.hpp"
#include "Point.hpp"

class Problem;
class Solution;

inline uint64_t calcD(Point pa, Point pb)
{
    return (uint64_t)((pb.x - pa.x) * (pb.x - pa.x) + (pb.y - pa.y) * (pb.y - pa.y));
}

inline bool isValidD(uint64_t dOld, uint64_t dNew, uint64_t epsilon)
{
    return
        (int64_t)dNew * 1000000 <= (1000000 + (int64_t)epsilon) * (int64_t)dOld &&
        (int64_t)dNew * 1000000 >= (1000000 - (int64_t)epsilon) * (int64_t)dOld;
}

bool isValid(const Problem& problem,
             const Solution& solution);

#endif
